# -*- coding: utf-8 -*-
import sys, json, re
from bs4 import BeautifulSoup
try:
    from urllib2 import urlopen, Request
except ImportError:
    from urllib.request import urlopen, Request
try:
    from urlparse import urlparse, urljoin
except ImportError:
    from urllib.parse import urlparse, urljoin
try:
    from urllib import urlencode, quote
except ImportError:
    from urllib.parse import urlencode, quote
ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4280.88 Safari/537.36'


def gethttp(url):
    request = Request(url, headers={'User-Agent': ua})
    return urlopen(request).read().decode('utf-8')


def getsoup(url):
    request = Request(url, headers={'User-Agent': ua})
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(urlopen(request), 'html.parser')
    return BeautifulSoup(urlopen(request), 'html5lib')


def detail(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'tangrenjie 300', 'error': str(e)}
    ret = []
    titles = []
    try:
        for e2 in soup.select('div.play_source_tab a b'):
            titles.append(e2.text)
        i = 0
        for e2 in soup.select('div.play_list_box'):
            sub = []
            for e3 in e2.select('div.playlist_full ul li a'):
                sub.append({'title': e3.text, 'url': urljoin(url, e3['href'])})
            ret.append({titles[i]: sub})
            i += 1
    except Exception as e:
        return {'code': 'tangrenjie 301', 'error': str(e)}
    return ret


def play(url):
    try:
        content = gethttp(url)
    except Exception as e:
        return {'code': 'tangrenjie 100', 'error': str(e)}
    temp = re.search(r'player_\w+=(.*?)</script>', content)
    if not temp:
        return {'code': 'tangrenjie 101'}
    data = json.loads(temp.group(1))
    u = ''
    d = {
        'Iw': ' ', #0x20
        'Ix': '!', #0x21
        'Iy': '"', #0x22
        'Iz': '#', #0x23
        'I0': '$', #0x24
        'I1': '%', #0x25
        'I2': '&', #0x26
        'I3': '\'', #0x27
        'I4': '(', #0x28
        'I5': ')', #0x29
        'JB': '*', #0x2A
        'JC': '+', #0x2B
        'JD': ',', #0x2C
        'JE': '-', #0x2D
        'JF': '.', #0x2E
        'JG': '/', #0x2F
        'Mw': '0', #0x30
        'Mx': '1', #0x31
        'My': '2', #0x32
        'Mz': '3', #0x33
        'M0': '4', #0x34
        'M1': '5', #0x35
        'M2': '6', #0x36
        'M3': '7', #0x37
        'M4': '8', #0x38
        'M5': '9', #0x39
        'NB': ':', #0x3A
        'NC': ';', #0x3B
        'ND': '<', #0x3C
        'NE': '=', #0x3D
        'NF': '>', #0x3E
        'NG': '?', #0x3F
        'Qw': '@', #0x40
        'Qx': 'A', #0x41
        'Qy': 'B', #0x42
        'Qz': 'C', #0x43
        'Q0': 'D', #0x44
        'Q1': 'E', #0x45
        'Q2': 'F', #0x46
        'Q3': 'G', #0x47
        'Q4': 'H', #0x48
        'Q5': 'I', #0x49
        'RB': 'J', #0x4A
        'RC': 'K', #0x4B
        'RD': 'L', #0x4C
        'RE': 'M', #0x4D
        'RF': 'N', #0x4E
        'RG': 'O', #0x4F
        'Uw': 'P', #0x50
        'Ux': 'Q', #0x51
        'Uy': 'R', #0x52
        'Uz': 'S', #0x53
        'U0': 'T', #0x54
        'U1': 'U', #0x55
        'U2': 'V', #0x56
        'U3': 'W', #0x57
        'U4': 'X', #0x58
        'U5': 'Y', #0x59
        'VB': 'Z', #0x5A
        'VC': '[', #0x5B
        'VD': '\\', #0x5C
        'VE': ']', #0x5D
        'VF': '^', #0x5E
        'VG': '_', #0x5F
        'Yw': '`', #0x60
        'Yx': 'a', #0x61
        'Yy': 'b', #0x62
        'Yz': 'c', #0x63
        'Y0': 'd', #0x64
        'Y1': 'e', #0x65
        'Y2': 'f', #0x66
        'Y3': 'g', #0x67
        'Y4': 'h', #0x68
        'Y5': 'i', #0x69
        'ZB': 'j', #0x6A
        'ZC': 'k', #0x6B
        'ZD': 'l', #0x6C
        'ZE': 'm', #0x6D
        'ZF': 'n', #0x6E
        'ZG': 'o', #0x6F
        'cw': 'p', #0x70
        'cx': 'q', #0x71
        'cy': 'r', #0x72
        'cz': 's', #0x73
        'c0': 't', #0x74
        'c1': 'u', #0x75
        'c2': 'v', #0x76
        'c3': 'w', #0x77
        'c4': 'x', #0x78
        'c5': 'y', #0x79
        'dB': 'z', #0x7A
        'dC': '{', #0x7B
        'dD': '|', #0x7C
        'dE': '}', #0x7D
        'dF': '~'} #0x7E
    for e in data['url'].split('JT'):
        if not e:
            continue
        if e not in d:
            return {'code': 'tangrenjie 102', 'error': u + '\n' + str(e)}
        u += d[e]
    return {'title': '', 'url': u}


def category(cat, page=1):
    url = 'https://www.tangrenjie.tv/vod/show/id/%s/page/%d.html' % (cat, page)
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'tangrenjie 200', 'error': str(e)}
    ret = []
    try:
        for e2 in soup.select('ul.vodlist li.vodlist_item a.vodlist_thumb'):
            plot = []
            for e3 in e2.select('span.vodlist_top em'):
                plot.append(e3.text)
            plot = '\n'.join(plot)
            ret.append({'title': e2['title'], 'url': urljoin(url, e2['href']), 'img': e2['data-original'], 'plot': plot})
    except Exception as e:
        return {'code': 'tangrenjie 201', 'error': str(e)}
    ret.append({'title': 'Next Page', 'category': cat, 'page': page + 1})
    return ret


def search(s, page=1):
    if not s:
        return {'code': 'tangrenjie 300'}
    url = 'https://www.tangrenjie.tv/vod/search/page/%d/wd/%s.html' % (page, quote(s))
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'tangrenjie 301', 'error': str(e)}
    ret = []
    for e1 in soup.select('ul.vodlist li.searchlist_item'):
        e2 = e1.select_one('div.searchlist_img a')
        title = e2['title']
        suburl = e2['href']
        img = e2['data-original']
        plot = []
        for e2 in e1.select('div.searchlist_titbox p.vodlist_sub'):
            plot.append(e2.text)
        plot = '\n'.join(plot)
        ret.append({'title': title, 'url': urljoin(url, suburl), 'img': img, 'plot': plot})
    e1 = soup.select_one('button.page_btn')
    if e1 and page < int(e1['data-total']):
        ret.append({'title': 'Next Page', 'search': s, 'page': page + 1})
    return ret
